"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rule_1 = require("../rule");
const meta_1 = require("../meta");
class AttributeAllowedValues extends rule_1.Rule {
    setup() {
        this.on('dom:ready', (event) => {
            const doc = event.document;
            doc.visitDepthFirst((node) => {
                const meta = node.meta;
                if (!meta || !meta.attributes)
                    return;
                for (const [key, attr] of Object.entries(node.attr)) {
                    if (!meta_1.Validator.validateAttribute(key, attr.value, meta.attributes)) {
                        this.report(node, `Attribute "${key}" has invalid value "${attr.value}"`, attr.location);
                    }
                }
            });
        });
    }
}
module.exports = AttributeAllowedValues;
