"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rule_1 = require("../rule");
const pattern_1 = require("../pattern");
const defaults = {
    pattern: 'kebabcase',
};
class IdPattern extends rule_1.Rule {
    constructor(options) {
        super(Object.assign({}, defaults, options));
        this.pattern = pattern_1.parsePattern(this.options.pattern);
    }
    setup() {
        this.on('attr', (event) => {
            if (event.key.toLowerCase() !== 'id') {
                return;
            }
            if (!event.value.match(this.pattern)) {
                this.report(event.target, `ID "${event.value}" does not match required pattern "${this.pattern}"`);
            }
        });
    }
}
module.exports = IdPattern;
