"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rule_1 = require("../rule");
class NoDeprecatedAttr extends rule_1.Rule {
    setup() {
        this.on('attr', (event) => {
            const node = event.target;
            const meta = node.meta;
            const attr = event.key.toLowerCase();
            if (meta === null) {
                return;
            }
            const deprecated = meta.deprecatedAttributes || [];
            if (deprecated.indexOf(attr) >= 0) {
                this.report(node, `Attribute "${event.key}" is deprecated on <${node.tagName}> element`);
            }
        });
    }
}
module.exports = NoDeprecatedAttr;
